import { createRoute } from "../../../modules/api-utils/createRoute";
import { unifiSites } from "../../../managers/unifiSites";
import { apiResponse } from "../../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../../middleware/authorization";

/* GET /v1/unifi/site/:id/networks */
export default createRoute(
  "get",
  ["/site/:id/networks"],
  async (c) => {
    const site = await unifiSites.fetch(c.req.param("id"));
    const networks = await unifiSites.getNetworks(site.siteId);
    const response = apiResponse.successful(
      "UniFi Networks Fetched Successfully!",
      networks,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({ permissions: ["unifi.access", "unifi.site.networks"] }),
);
